* Common routine for Bxxx
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01, pjw, 1996 Apr, unreliable 16 bit returns
* V0.02, pjw, 2023 Aug 17, re-wrote and simpliefied
* (V0.03 - direct mmemory access too?)
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef pars,ret0,ret1,retval,retint

        xref lin2flt,fputp

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err

*
pars
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* Common parameter fetch and return routines for Bxxx
*
* Returns to previous caller on error

        move.w sb.gtlin,a2
        jsr (a2)
        bne.s quit

        subq.w #2,d3
        bne.s err_bp

        movem.l (a6,a1.l),d5/d6
        rts

err_bp
        moveq #err.ipar,d0

quit
        addq.l #4,sp
        rts

*
* Return integer 1 (Stack must be all in order for this call)
*
ret1
        moveq #1,d5
        bra.s retval

*
* Return integer 0 (Stack must be all in order for this call)
*
ret0
        moveq #0,d5

*
* Float and stuff value in d6 into last par. Stack must be -8
*
retval
        addq.l #8,a3            value is at last par
        move.l d6,d1
        bsr lin2flt             float
        bsr fputp               stuff it

*
* Return integer. Stack must be at -2 here
*
retint
        movea.l sb_arthp(a6),a1
        move.w d5,(a6,a1.l)
        moveq #ar.int,d4
        moveq #0,d0
        rts

*
        end
